/*Maysa Macedo- maysa ( at) ime.usp.br*/
import java.io.IOException;
import java.io.PrintStream;
import java.net.Socket;
import java.rmi.RemoteException;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;


/**
 *
 * @author maysa
 */
public class AtualizadorCenario extends Thread {

    // Flag que indica quando se deve terminar a execução.
    private static boolean done = false;

    //parte que controla a recepção de mensagens deste cliente
    private Socket conexao;

    // construtor que recebe o socket deste cliente
    public AtualizadorCenario(Socket conexao, Integer idJogador, Integer idPartida) {
        PrintStream saida = null;
        try {
            this.conexao = conexao;
            saida = new PrintStream(conexao.getOutputStream());
            saida.println(idJogador);
            saida.println(idPartida);
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
           // saida.close();
        }
    }


    @Override
    public void run(){
        try {
            Scanner entrada = new Scanner(conexao.getInputStream());
            String linha;
            while (true) {
                // verifica se é uma linha válida. Pode ser que a conexão
                // tenha sido interrompida. Neste caso, a linha é null. Se isso
                // ocorrer, termina-se a execução saindo com break
                if (!entrada.hasNext()) {
                    System.out.println("Conexão encerrada!");
                    ControladorPartidaCliente.getTelaPrincipal().fecharPartidaNaoPrevista();
                    break;
                }
                //pega o que o servidor enviou
                linha = entrada.nextLine();
                if(linha.equals("1")){
                    try {
                        if (ControladorPartidaCliente.getInstance().getCenario()!= null)
                            try {
                            ControladorPartidaCliente.getInstance().atualizarCenario();
                        } catch (NoSuchFieldException ex) {
                            Logger.getLogger(AtualizadorCenario.class.getName()).log(Level.SEVERE, null, ex);
                        } catch (IllegalArgumentException ex) {
                            Logger.getLogger(AtualizadorCenario.class.getName()).log(Level.SEVERE, null, ex);
                        } catch (IllegalAccessException ex) {
                            Logger.getLogger(AtualizadorCenario.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    } catch (RemoteException ex) {
                        Logger.getLogger(AtualizadorCenario.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
                else{ if (linha.equals("2")|| linha.equals("3")){
                        ControladorPartidaCliente.getInstance().expirarPartida();
                }

                }
                System.out.println();
                System.out.println(linha);
                System.out.print("...> ");

            }
        } catch (IOException e) {
            // caso ocorra alguma exceção de E/S, mostre qual foi.
            System.out.println("IOException: " + e);
        }
        // sinaliza para o main que a conexão encerrou.
        done = true;


        
    }
   
}
