/*Maysa Macedo- maysa ( at) ime.usp.br*/

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;


public class CenarioTO implements Serializable {
    private Integer cod_partida;
    private ArrayList<JogadorTO> jogadores;
    private EspacoTO[][] espacos;
    private Integer direcao;
    private Integer camadaOzonio;
    private ArrayList<CartaGeneTO> cartaGeneLivre;
    private Timestamp dataInicio;
    private Integer rodada;
    private Long atualizacaoCenario;
    private Integer fase;
    private ArrayList<Integer> ordemExecucao;
    private Boolean partidaFechada;
    private Integer vencedor;
    private Boolean partidaInterrompida;

    public CenarioTO(){
        jogadores = new ArrayList<JogadorTO>();
        cartaGeneLivre = new ArrayList<CartaGeneTO>();
        espacos = new EspacoTO[5][5];
        partidaInterrompida = false;
        EspacoTO espaco= new EspacoTO();
        espaco.setAmeba(null);
        espaco.setNutriente1(0);
        espaco.setNutriente2(0);
        espaco.setNutriente3(0);
        espaco.setNutriente4(0);
        for (int i=0;i<espacos.length;i++)
            for(int j=0;j<espacos[1].length;j++){
               espacos[i][j] = espaco;
            }


    }

    /**
     * @return the cod_partida
     */
    public Integer getCod_partida() {
        return cod_partida;
    }

    /**
     * @param cod_partida the cod_partida to set
     */
    public void setCod_partida(Integer cod_partida) {
        this.cod_partida = cod_partida;
    }

    /**
     * @return the jogadores
     */
    public ArrayList<JogadorTO> getJogadores() {
        return jogadores;
    }

    public JogadorTO getJogador(Integer codJogador) {
         int i;
         for(i=0;i<jogadores.size();i++){
                if (jogadores.get(i).getCodigo().equals(codJogador))
                     return jogadores.get(i);
         }
        return null;
      }

    public void  setJogadores(ArrayList<JogadorTO> jogadores) {
        this.jogadores = jogadores;

    }
/**
     * @return the espacos
     */
    public EspacoTO[][] getEspacos() {
        return espacos;
    }

     public void  setEspacos(EspacoTO[][] espacos) {
        this.espacos =  espacos;
    }
    /**
     * @return the direcao
     */
    public Integer getDirecao() {
        return direcao;
    }

    /**
     * @param direcao the direcao to set
     */
    public void setDirecao(Integer direcao) {
        this.direcao = direcao;
    }

    /**
     * @return the camadaOzonio
     */
    public Integer getCamadaOzonio() {
        return camadaOzonio;
    }

    /**
     * @param camadaOzonio the camadaOzonio to set
     */
    public void setCamadaOzonio(Integer camadaOzonio) {
        this.camadaOzonio = camadaOzonio;
    }

    /**
     * @return the cartaGeneLivre
     */
    public ArrayList<CartaGeneTO> getCartaGeneLivre() {
        return cartaGeneLivre;
    }

    public void setCartaGeneLivre( ArrayList<CartaGeneTO> cartaGeneLivre) {
        this.cartaGeneLivre = cartaGeneLivre;
    }
    /**
     * @return the hora
     */
  
    /**
     * @return the dataInicio
     */
    public Timestamp getDataInicio() {
        return dataInicio;
    }

    /**
     * @param dataInicio the dataInicio to set
     */
    public void setDataInicio(Timestamp dataInicio) {
        this.dataInicio = dataInicio;
    }

    /**
     * @return the rodada
     */
    public Integer getRodada() {
        return rodada;
    }

    /**
     * @param rodada the rodada to set
     */
    public void setRodada(Integer rodada) {
        this.rodada = rodada;
    }

    public Long getAtualizacaoCenario() {
        return this.atualizacaoCenario;
    }

    /**
     * @param cod_partida the cod_partida to set
     */
    public void setAtualizacaoCenario(Long atualizacaoCenario) {
        this.atualizacaoCenario = atualizacaoCenario;
    }

    /**
     * @return the fase
     */
    public Integer getFase() {
        return fase;
    }

    /**
     * @param fase the fase to set
     */
    public void setFase(Integer fase) {
        this.fase = fase;
    }

    /**
     * @return the ordemExecucao
     */
    public ArrayList<Integer> getOrdemExecucao() {
        return ordemExecucao;
    }

    /**
     * @param ordemExecucao the ordemExecucao to set
     */
    public void setOrdemExecucao(ArrayList<Integer> ordemExecucao) {
        this.ordemExecucao = ordemExecucao;
    }

    /**
     * @return the partidaFechada
     */
    public Boolean getPartidaFechada() {
        return partidaFechada;
    }

    /**
     * @param partidaFechada the partidaFechada to set
     */
    public void setPartidaFechada(Boolean partidaFechada) {
        this.partidaFechada = partidaFechada;
    }

    /**
     * @return the vencedor
     */
    public Integer getVencedor() {
        return vencedor;
    }

    /**
     * @param vencedor the vencedor to set
     */
    public void setVencedor(Integer vencedor) {
        this.vencedor = vencedor;
    }

    /**
     * @return the partidaInterrompida
     */
    public Boolean getPartidaInterrompida() {
        return partidaInterrompida;
    }

    /**
     * @param partidaInterrompida the partidaInterrompida to set
     */
    public void setPartidaInterrompida(Boolean partidaInterrompida) {
        this.partidaInterrompida = partidaInterrompida;
    }

   
}
