/*Maysa Macedo- maysa ( at) ime.usp.br*/

/*Classe que gerencia requisicoes e geracoes de historico de partida*/

import bancodados.PrimordialSoupDAO;
import java.sql.SQLException;
import java.util.ArrayList;
import primordialsoupservidor.Historico;


public class GerenteHistorico {
 private static GerenteHistorico instancia = new GerenteHistorico();


    private  GerenteHistorico(){

    }

    public static GerenteHistorico getInstance(){
        return instancia;
    }
 public ArrayList<HistoricoTO> solicitarHistorico(Integer codJogador) throws SQLException{
          int i; int j;
          ArrayList<Historico> historico = new ArrayList<Historico>();
          PrimordialSoupDAO connection = new PrimordialSoupDAO();
          historico = connection.getHistorico(codJogador);

          
          return toHistoricoTO(historico);
}


 public ArrayList<HistoricoTO> toHistoricoTO(ArrayList<Historico> historico){
   int i;
   ArrayList<HistoricoTO> historicoToLista = new ArrayList<HistoricoTO>();
   if (historico !=null){
       for(i=0;i< historico.size();i++){
           HistoricoTO historicoTo = new HistoricoTO();
           historicoTo.setData(historico.get(i).getData());
           historicoTo.setDuracao(historico.get(i).getDuracao());
           historicoTo.setJogadores(historico.get(i).getJogadores());
           historicoTo.setPontuacoes(historico.get(i).getPontuacoes());
           historicoTo.setVencedor(historico.get(i).getVencedor());
           historicoToLista.add(historicoTo);
        }
       return historicoToLista;
   }
   return null;

 }




}
