/*Maysa Macedo- maysa ( at) ime.usp.br*/

/*Classe que gerencia todas as regras do jogo.*/
import bancodados.PrimordialSoupDAO;
import java.sql.SQLException;
import java.util.ArrayList;
import primordialsoupservidor.*;



public class GerenteJogo{

    private static GerenteJogo instancia = new GerenteJogo();


    private  GerenteJogo(){

    }

    public static GerenteJogo getInstance(){
        return instancia;
    }

    public Integer jogar2Dado(){
         
         Integer dado1=0;
         Integer dado2=0;
         dado1 = (Integer)(1+ (int)(Math.random() * 5));
         dado2 = (Integer)(1+ (int)(Math.random() * 5));
         
         return dado1+dado2;
    }
     public Integer jogar1Dado(){

         Integer dado1=0;

         dado1 = (Integer)(1+ (int)(Math.random() * 5));


         return dado1;
    }
     //registra o valor do dado apenas para a rodada zero
    public CenarioTO registrarDado(Integer codPartida, Integer codJogador, Integer valorDado){
          int i; int j;
          Integer [] ordemDados = new Integer[4];
          ArrayList<Integer> codigoVencedor = new ArrayList<Integer>();
          Integer min=0;Integer codigo=0;

          Partida partida = GerentePartida.getInstance().getPartida(codPartida);
          ArrayList<PartidaAtual> partidaAtual=null;
          if (partida != null){
               partidaAtual = partida.getListaPartidaAtual();
                //adiciona valor do dado ao jogador
               for (i=0 ; i< partida.getListaPartidaAtual().size(); i++){
                    if (partidaAtual.get(i).getJogador().getCodigo().equals(codJogador)){
                        partidaAtual.get(i).getJogador().setValorDado(valorDado);
                        break;
                    }
               }
               //se estah na rodada zero
               
              if (partida.getRodada().equals(0)){
                  if (partida.getJogadoresDeDado().equals(4)){
                      partida.getOrdemExecucao().remove(codJogador);
                      for (i=0 ; i< partida.getListaPartidaAtual().size(); i++){
                          codigoVencedor.add(partidaAtual.get(i).getJogador().getCodigo()) ;
                          ordemDados[i] = partidaAtual.get(i).getJogador().getValorDado();
                          partidaAtual.get(i).getJogador().setValorDado(0);            //zera o valor do dado
                    }
                     
                    //ordena os jogadores do menor valor para o maior valor
                    for (i=1 ; i< partida.getListaPartidaAtual().size(); i++){             //ordena o array de maiores
                        min    = ordemDados[i];
                        codigo =  codigoVencedor.get(i);
                        for(j=i;j>0;j--)
                        {   
                            if (ordemDados[j-1] < min){
                               ordemDados[j] = ordemDados[j-1];
                               codigoVencedor.set(j,codigoVencedor.get(j-1)) ;
                           }
                            else
                              break;
                        }
                         
                        ordemDados[j] = min;
                        codigoVencedor.set(j, codigo);
                        
                   }
                   partida.setOrdemExecucao(codigoVencedor);
                   partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
                   partida.notificarJogadores();
                  } //se nao tiver 4 valores de dado
                  else{
                    partida.getOrdemExecucao().remove(codJogador);
                    partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
                  }

             }

          } else
              return null;

        return GerentePartida.getInstance().toCenario(partida);


    }



      public CenarioTO escolherMarcador(Integer codPartida, Integer codjogador, Integer cor , Integer posicao){
          int i,j;
          Espaco espacos[][];
          ArrayList<Integer> matrizValor = new ArrayList<Integer>();
          ArrayList<Integer> matrizCodigo = new ArrayList<Integer>();
          Partida partida = GerentePartida.getInstance().getPartida(codPartida);
          if (partida != null){

                
                PartidaAtual partidaAtual = partida.getPartidaAtual(codjogador);
                partidaAtual.setPontos(posicao);
                partidaAtual.EscolherCor(cor);
                //Todos iniciam com 4 pontos biologicos
                partidaAtual.setPontoBiologico(Integer.parseInt("4"));
                //adiciona 7 amebas
                for(i=0;i<7;i++){
                    Ameba ameba = new Ameba();
                    ameba.setCor(cor);
                    ameba.setNumero( (Integer) i+1 );
                    ameba.setPontoPrejudicial(0);
                    ameba.setEstaTabuleiro(false);
                    
                    partidaAtual.addAmebas(ameba);
                }
                   

                //adiciona uma partida atual já existente
                partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
               
                //o tabuleiro inicia com 2 nutrientes de cada cor
                espacos = partida.getEspacos();
                for(i=0;i<espacos.length;i++ )
                    for(j=0;j<espacos[1].length;j++ ){
                        espacos[i][j].setNutriente1(Integer.parseInt("2"));
                        espacos[i][j].setNutriente2(Integer.parseInt("2"));
                        espacos[i][j].setNutriente3(Integer.parseInt("2"));
                        espacos[i][j].setNutriente4(Integer.parseInt("2"));
                    }
                partida.setEspacos(espacos);
                ArrayList<PartidaAtual> partidasAtuais = partida.getListaPartidaAtual();
                int contador=0;
                for(i=0; i < partidasAtuais.size();i++){
                        if (!partidasAtuais.get(i).getCor().equals(0)){
                            contador=contador+1;
                        }
                }
                if (contador==4){//acertar a ordem  só funciona por que os pontos neste caso, vao de 1 a 4
                     //primeira rodada
                     partida.setRodada(Integer.parseInt("1"));
                     for(i=0;i<partida.getListaPartidaAtual().size();i++){
                         matrizCodigo.add(partida.getListaPartidaAtual().get(i).getJogador().getCodigo());
                         matrizValor.add(partida.getListaPartidaAtual().get(i).getPontos());
                     }
                     ordenarCrescente(partida.getListaPartidaAtual().size(), matrizValor, matrizCodigo);
                     partida.setOrdemExecucao(matrizCodigo);
                }
                else{
                     partida.getOrdemExecucao().remove(codjogador);
                }
                 partida.notificarJogadores();
                return GerentePartida.getInstance().toCenario(partida);
           }
          else return null;



    }

  //primeira rodada
 
   public CenarioTO adicionarAmeba(Integer codPartida, Integer codJogador, AmebaTO amebato, Integer x, Integer y){
      System.out.println("Adicionando ameba.");
      int i,j;
      int contador=0;
      ArrayList<Integer> matrizValor = new ArrayList<Integer>();
      ArrayList<Integer> matrizCodigo = new ArrayList<Integer>();
     
      Partida partida = GerentePartida.getInstance().getPartida(codPartida);
      if (partida != null){
           PartidaAtual partidaAtual = partida.getPartidaAtual(codJogador);
           Ameba ameba = partidaAtual.getAmeba(amebato.getCor(), amebato.getNumero());
           if (!partida.getFase().equals(0)){
                if (partidaAtual.quantidadeAmebaTabuleiro()>0)
                    if(partidaAtual.temCartaTaxaDivisao()){
                    //debitar 4 pb's
                    partidaAtual.debitarPontoBiologico(Integer.parseInt(Messages.getString("PONTODEBITODIVISAOCELULARCARTA")));
                    }else{
                     //debitar 6 pb's
                    partidaAtual.debitarPontoBiologico(Integer.parseInt(Messages.getString("PONTODEBITODIVISAOCELULAR")));
                    }
            }//se for a primeira adicao de ameba no tabuleiro durante a partida, adiciona 1 ponto prejudicial
            else{
                if(partidaAtual.quantidadeAmebaTabuleiro().equals(0)){
                        ameba.setPontoPrejudicial(1);
                }
                for(i=0;i< partida.getEspacos().length;i++)
                    for(j=0;j<partida.getEspacos()[1].length;j++)
                       contador = contador + partida.getEspacos()[i][j].getAmebas().size();
                 partida.getOrdemExecucao().remove(codJogador);
                //se essa for a oitava ameba a ser inserida , passa para a fase 1 de movimentacao.
                if (contador==3 || contador==7) {
                    
                    for(i=0;i<partida.getListaPartidaAtual().size();i++){
                        matrizCodigo.add(partida.getListaPartidaAtual().get(i).getJogador().getCodigo());
                        matrizValor.add(partida.getListaPartidaAtual().get(i).getPontos());
                    }
                    ordenarCrescente(partida.getListaPartidaAtual().size(), matrizValor, matrizCodigo);
                    partida.setOrdemExecucao(matrizCodigo);
                }
                if (contador==7) 
                    partida.setFase(1);
            }
            ameba.setEstaTabuleiro(true);
            ameba.setX(x);
            ameba.setY(y);
            partida.getEspacos()[x][y].getAmebas().add(ameba);
            partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
            Ameba ameba2 = partidaAtual.getAmeba(amebato.getCor(), amebato.getNumero());
            partida.notificarJogadores(); //avisa para os jogadores dessa partida que o cenário mudou
            return GerentePartida.getInstance().toCenario(partida);
       }
      else return null;
    }
        // fase zero
        public Integer[][] escolherEspaco(Integer codPartida, Integer codJogador){
          int i,j,z;
         
          Espaco[][] espaco;
          Integer[][] espacoNovo= new Integer[5][5];
           System.out.println("Escolher espaco.");

          Partida partida = GerentePartida.getInstance().getPartida(codPartida);
          if (partida != null){
              espaco = partida.getEspacos();
          
                if (partida.getFase().equals(0)){// fase zero - procurar todos os espacos vazios
                    for(i = 0; i < 5; i++)
                        for( j = 0; j < 5 ; j++){
                            if ( (espaco[i][j].getAmebas().size() == 0) && !((i==0 && j==0)||(i==2 && j==2)||(i==0 && j==2)||(i==0 && j==3)||(i==0 && j==4)||(i==4 && j==4)))
                                    espacoNovo[i][j] =  1;
                            else
                                    espacoNovo[i][j] = 0;


                        }
                }
                return espacoNovo;
          }

         for(i = 0; i < 5; i++)
             for( j = 0; j < 5 ; j++){
                  espacoNovo[i][j] = 0;}
         return espacoNovo;
 }



 //verificar se remove Ameba está realmente funcionando
 public CenarioTO deslizarAmeba(Integer codPartida, Integer codJogador, AmebaTO amebato,Integer x1, Integer y1, Integer x2, Integer y2){
     System.out.println("Deslizando ameba.");
     Ameba ameba;
     Partida partida = GerentePartida.getInstance().getPartida(codPartida);
     if (partida != null){
         PartidaAtual partidaAtual = partida.getPartidaAtual(codJogador);
         ameba = partidaAtual.getAmeba(amebato.getCor(), amebato.getNumero());
         ameba.setX(x2);
         ameba.setY(y2);
         partida.getEspacos()[x1][y1].removeAmeba(ameba);
         partida.getEspacos()[x2][y2].addAmeba(ameba);
         partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
         return GerentePartida.getInstance().toCenario(partida);

     }
    return null;
 }


 public CenarioTO movimentarAmeba(Integer codPartida, Integer codJogador, AmebaTO amebato,Integer x1, Integer y1, Integer x2, Integer y2){
     System.out.println("Movimentando ameba.");
     Ameba ameba;
     Partida partida = GerentePartida.getInstance().getPartida(codPartida);
     if (partida != null){
         PartidaAtual partidaAtual = partida.getPartidaAtual(codJogador);
         ameba = partidaAtual.getAmeba(amebato.getCor(), amebato.getNumero());
         ameba.setX(x2);
         ameba.setY(y2);
         partida.getEspacos()[x1][y1].removeAmeba(ameba);
         partida.getEspacos()[x2][y2].addAmeba(ameba);
         partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
         //debita 1 BP
         if (!partidaAtual.temCartaAerodinamica()) //carta aerodinâmica
             partidaAtual.setPontoBiologico(partidaAtual.getPontoBiologico()-1);
         
         return GerentePartida.getInstance().toCenario(partida);

     }
    return null;
 }


//cartas
 public CenarioTO comerNutriente(Integer codPartida, Integer codJogador, AmebaTO amebato, Integer x, Integer y, EspacoTO espaco){
     System.out.println("Comendo Nutriente.");
     Ameba ameba = null;
     boolean estaFaminto = false;
     Partida partida = GerentePartida.getInstance().getPartida(codPartida);
     if (partida != null){
         PartidaAtual partidaAtual = partida.getPartidaAtual(codJogador);
         ameba = partidaAtual.getAmeba(amebato.getCor(), amebato.getNumero());
         if (ameba.getCor() == 1){
             if ((partida.getEspacos()[x][y].getNutriente2()>=espaco.getNutriente2())&& (partida.getEspacos()[x][y].getNutriente3()>=espaco.getNutriente3()) && (partida.getEspacos()[x][y].getNutriente4()>=espaco.getNutriente4()))
             {   if (espaco.getNutriente3()>0 && espaco.getNutriente2()>0 && espaco.getNutriente4()>0){
                     //come
                   partida.getEspacos()[x][y].setNutriente2(partida.getEspacos()[x][y].getNutriente2()-espaco.getNutriente2());
                   partida.getEspacos()[x][y].setNutriente3(partida.getEspacos()[x][y].getNutriente3()-espaco.getNutriente3());
                   partida.getEspacos()[x][y].setNutriente4(partida.getEspacos()[x][y].getNutriente4()-espaco.getNutriente4());
                   //excreta
                   partida.getEspacos()[x][y].setNutriente1(partida.getEspacos()[x][y].getNutriente1()+2);
                   }else{
                     if(partidaAtual.temCartaFrugalidade()){
                            if ((espaco.getNutriente3()>0 && espaco.getNutriente2()>0) || (espaco.getNutriente3()>0 && espaco.getNutriente4()>0) || (espaco.getNutriente2()>0 && espaco.getNutriente4()>0)){
                                 //come
                               partida.getEspacos()[x][y].setNutriente2(partida.getEspacos()[x][y].getNutriente2()-espaco.getNutriente2());
                               partida.getEspacos()[x][y].setNutriente3(partida.getEspacos()[x][y].getNutriente3()-espaco.getNutriente3());
                               partida.getEspacos()[x][y].setNutriente4(partida.getEspacos()[x][y].getNutriente4()-espaco.getNutriente4());
                               //excreta
                               partida.getEspacos()[x][y].setNutriente1(partida.getEspacos()[x][y].getNutriente1()+2);

                             }else    estaFaminto=true;
                     }else    estaFaminto=true;
                   }
             
             }else{   estaFaminto =true;}

         }
         if (ameba.getCor() == 2){
             if ((partida.getEspacos()[x][y].getNutriente1()>=espaco.getNutriente1())&& (partida.getEspacos()[x][y].getNutriente3()>=espaco.getNutriente3()) && (partida.getEspacos()[x][y].getNutriente4()>=espaco.getNutriente4()))
             {   if (espaco.getNutriente1()>0 && espaco.getNutriente3()>0 && espaco.getNutriente4()>0){
                         //come
                    partida.getEspacos()[x][y].setNutriente1(partida.getEspacos()[x][y].getNutriente1()-espaco.getNutriente1());
                    partida.getEspacos()[x][y].setNutriente3(partida.getEspacos()[x][y].getNutriente3()-espaco.getNutriente3());
                    partida.getEspacos()[x][y].setNutriente4(partida.getEspacos()[x][y].getNutriente4()-espaco.getNutriente4());
                    //excreta
                    partida.getEspacos()[x][y].setNutriente2(partida.getEspacos()[x][y].getNutriente2()+2);
                 }else{
                     if(partidaAtual.temCartaFrugalidade()){
                            if ((espaco.getNutriente3()>0 && espaco.getNutriente1()>0) || (espaco.getNutriente3()>0 && espaco.getNutriente4()>0) || (espaco.getNutriente1()>0 && espaco.getNutriente4()>0)){
                                 //come
                                partida.getEspacos()[x][y].setNutriente1(partida.getEspacos()[x][y].getNutriente1()-espaco.getNutriente1());
                                partida.getEspacos()[x][y].setNutriente3(partida.getEspacos()[x][y].getNutriente3()-espaco.getNutriente3());
                                partida.getEspacos()[x][y].setNutriente4(partida.getEspacos()[x][y].getNutriente4()-espaco.getNutriente4());
                                //excreta
                                partida.getEspacos()[x][y].setNutriente2(partida.getEspacos()[x][y].getNutriente2()+2);

                             }else    estaFaminto=true;
                     }else    estaFaminto=true;
                   }
             }
             else{
                 estaFaminto =true;
             }
         }if (ameba.getCor() == 3){
             if ((partida.getEspacos()[x][y].getNutriente2()>=espaco.getNutriente2())&& (partida.getEspacos()[x][y].getNutriente1()>=espaco.getNutriente1()) && (partida.getEspacos()[x][y].getNutriente4()>=espaco.getNutriente4()))
             {   if (espaco.getNutriente1()>0 && espaco.getNutriente2()>0 && espaco.getNutriente4()>0){
                     //come
                   partida.getEspacos()[x][y].setNutriente2(partida.getEspacos()[x][y].getNutriente2()-espaco.getNutriente2());
                   partida.getEspacos()[x][y].setNutriente1(partida.getEspacos()[x][y].getNutriente1()-espaco.getNutriente1());
                   partida.getEspacos()[x][y].setNutriente4(partida.getEspacos()[x][y].getNutriente4()-espaco.getNutriente4());

                   //excreta
                   partida.getEspacos()[x][y].setNutriente3(partida.getEspacos()[x][y].getNutriente3()+2);
                    }else{
                     if(partidaAtual.temCartaFrugalidade()){
                            if ((espaco.getNutriente2()>0 && espaco.getNutriente1()>0) || (espaco.getNutriente2()>0 && espaco.getNutriente4()>0) || (espaco.getNutriente1()>0 && espaco.getNutriente4()>0)){
                                //come
                               partida.getEspacos()[x][y].setNutriente2(partida.getEspacos()[x][y].getNutriente2()-espaco.getNutriente2());
                               partida.getEspacos()[x][y].setNutriente1(partida.getEspacos()[x][y].getNutriente1()-espaco.getNutriente1());
                               partida.getEspacos()[x][y].setNutriente4(partida.getEspacos()[x][y].getNutriente4()-espaco.getNutriente4());

                               //excreta
                               partida.getEspacos()[x][y].setNutriente3(partida.getEspacos()[x][y].getNutriente3()+2);

                             }else    estaFaminto=true;
                     }else    estaFaminto=true;
                   }
             }
             else{
                estaFaminto =true;
             }
         }if (ameba.getCor() == 4){
             if ((partida.getEspacos()[x][y].getNutriente2()>=espaco.getNutriente2())&& (partida.getEspacos()[x][y].getNutriente3()>=espaco.getNutriente3()) && (partida.getEspacos()[x][y].getNutriente1()>=espaco.getNutriente1()))
             {   if (espaco.getNutriente1()>0 && espaco.getNutriente2()>0 && espaco.getNutriente3()>0){
                   //come
                   partida.getEspacos()[x][y].setNutriente2(partida.getEspacos()[x][y].getNutriente2()-espaco.getNutriente2());
                   partida.getEspacos()[x][y].setNutriente3(partida.getEspacos()[x][y].getNutriente3()-espaco.getNutriente3());
                   partida.getEspacos()[x][y].setNutriente1(partida.getEspacos()[x][y].getNutriente1()-espaco.getNutriente1());

                   //excreta
                   partida.getEspacos()[x][y].setNutriente4(partida.getEspacos()[x][y].getNutriente4()+2);
                 }else{
                     if(partidaAtual.temCartaFrugalidade()){
                            if ((espaco.getNutriente2()>0 && espaco.getNutriente1()>0) || (espaco.getNutriente2()>0 && espaco.getNutriente3()>0) || (espaco.getNutriente1()>0 && espaco.getNutriente3()>0)){
                               //come
                               partida.getEspacos()[x][y].setNutriente2(partida.getEspacos()[x][y].getNutriente2()-espaco.getNutriente2());
                               partida.getEspacos()[x][y].setNutriente3(partida.getEspacos()[x][y].getNutriente3()-espaco.getNutriente3());
                               partida.getEspacos()[x][y].setNutriente1(partida.getEspacos()[x][y].getNutriente1()-espaco.getNutriente1());

                               //excreta
                               partida.getEspacos()[x][y].setNutriente4(partida.getEspacos()[x][y].getNutriente4()+2);

                             }else    estaFaminto=true;
                     }else    estaFaminto=true;
                   }
             }
             else{
                estaFaminto =true;
             }
          }
          //se faminto recebe ponto prejudicial
          if (estaFaminto){
             ameba.setPontoPrejudicial(ameba.getPontoPrejudicial()+1);

          }
          partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
          partida.notificarJogadores();
         return GerentePartida.getInstance().toCenario(partida);
        }  
        

    return null;
 }
 public CenarioTO mudarParaFase2(Integer codPartida, Integer codJogador){
     System.out.println("Cada jogador avisa que está pronto para mudar para fase 2.");
     int i;
     ArrayList<Integer> matrizValor = new ArrayList<Integer>();
     ArrayList<Integer> matrizCodigo = new ArrayList<Integer>();
      Partida partida = GerentePartida.getInstance().getPartida(codPartida);
      if ( partida.getOrdemExecucao().size()==1){
           partida.getOrdemExecucao().remove(codJogador);
           partida.setFase(2);
           partida.MudarCartaAmbiente();
           for(i=0;i<partida.getListaPartidaAtual().size();i++){
                matrizCodigo.add(partida.getListaPartidaAtual().get(i).getJogador().getCodigo());
                matrizValor.add(partida.getListaPartidaAtual().get(i).getPontos());
           }
           ordenarDecrescente(partida.getListaPartidaAtual().size(), matrizValor, matrizCodigo);
           partida.setOrdemExecucao(matrizCodigo);
      }else
          partida.getOrdemExecucao().remove(codJogador);

      partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
      partida.notificarJogadores();
      return GerentePartida.getInstance().toCenario(partida);

  }

 public Integer calcularMulta(Integer codPartida, Integer codJogador){
     System.out.println("Calculando multa.");
     int i;Integer multa=0, soma=0;
     Partida partida = GerentePartida.getInstance().getPartida(codPartida);
     
     for(i=0;i<partida.getPartidaAtual(codJogador).getCartasGene().size();i++){
        soma = soma +partida.getPartidaAtual(codJogador).getCartasGene().get(i).getPontoMutacao();
     }
     
     if (soma > partida.getCartaAmbienteAtual().getCamaOzonio())
         multa = soma - partida.getCartaAmbienteAtual().getCamaOzonio();
     
     
     return multa;
 }


public CenarioTO pagarMulta(Integer codPartida, Integer codJogador, ArrayList<CartaGeneTO> cartasGene, Integer pontoBiologico){
    System.out.println("Jogador pagando multa.");
    int i;
    Partida partida = GerentePartida.getInstance().getPartida(codPartida);
    PartidaAtual partidaAtual  = partida.getPartidaAtual(codJogador);
    if (partida!=null){
        if (pontoBiologico > 0)
            partidaAtual.setPontoBiologico(partidaAtual.getPontoBiologico()-pontoBiologico);
        if (cartasGene!=null)
            {    for(i=0; i<cartasGene.size(); i++){
                     CartaGene cartagene = new CartaGene();
                     cartagene.setCodigo(cartasGene.get(i).getCodigo());
                     cartagene.setNome(cartasGene.get(i).getNome());
                     cartagene.setPontoMutacao(cartasGene.get(i).getPontoMutacao());
                     cartagene.setPreco(cartasGene.get(i).getPreco());
                    
                 }
            }
             partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
             partida.notificarJogadores();
            return(GerentePartida.getInstance().toCenario(partida));
    }
    return null;

}
public CenarioTO mudarParaFase3(Integer codPartida, Integer codJogador){
     System.out.println("Cada jogador avisa que está pronto para mudar para fase 3.");
     int i;
     ArrayList<Integer> matrizValor = new ArrayList<Integer>();
     ArrayList<Integer> matrizCodigo = new ArrayList<Integer>();
      Partida partida = GerentePartida.getInstance().getPartida(codPartida);
      if (partida.getOrdemExecucao().size()==1){
           partida.getOrdemExecucao().remove(codJogador);
           partida.setFase(3);
           for(i=0;i<partida.getListaPartidaAtual().size();i++){
                matrizCodigo.add(partida.getListaPartidaAtual().get(i).getJogador().getCodigo());
                matrizValor.add(partida.getListaPartidaAtual().get(i).getPontos());
           }
           ordenarDecrescente(partida.getListaPartidaAtual().size(), matrizValor, matrizCodigo);
           partida.setOrdemExecucao(matrizCodigo);
      }else
          partida.getOrdemExecucao().remove(codJogador);

      partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
      partida.notificarJogadores();
      return GerentePartida.getInstance().toCenario(partida);

  }
public CenarioTO comprarGene(Integer codPartida, Integer codJogador,ArrayList<CartaGeneTO> cartasGeneTo) {
    System.out.println("Comprando genes.");
    int i, j;
    Partida partida = GerentePartida.getInstance().getPartida(codPartida);
    PartidaAtual partidaAtual  = partida.getPartidaAtual(codJogador);
    if (partida!=null){
        if (cartasGeneTo!=null)

            {    
                 for(i=0; i<cartasGeneTo.size(); i++){
                     CartaGene cartagene = new CartaGene();
                     cartagene.setCodigo(cartasGeneTo.get(i).getCodigo());
                     cartagene.setNome(cartasGeneTo.get(i).getNome());
                     cartagene.setPontoMutacao(cartasGeneTo.get(i).getPontoMutacao());
                     cartagene.setPreco(cartasGeneTo.get(i).getPreco());
                     partidaAtual.getCartasGene().add(cartagene);
                     System.out.println("vendeu essa carta gene:"+   cartagene.getNome());
                     partidaAtual.debitarPontoBiologico(cartagene.getPreco());
                     partida.getCatalogoCartaGene().getCartaGene().remove(cartagene);
                     
                 }
            }
             partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
             partida.notificarJogadores();
             return(GerentePartida.getInstance().toCenario(partida));
    }
return null;
}

public CenarioTO mudarParaFase4(Integer codPartida, Integer codJogador){
     System.out.println("Cada jogador avisa que está pronto para mudar para fase 4.");
     int i;
     ArrayList<Integer> matrizValor = new ArrayList<Integer>();
     ArrayList<Integer> matrizCodigo = new ArrayList<Integer>();
      Partida partida = GerentePartida.getInstance().getPartida(codPartida);
      if (partida.getOrdemExecucao().size()==1){
           partida.getOrdemExecucao().remove(codJogador);
           partida.setFase(4);

           for(i=0;i<partida.getListaPartidaAtual().size();i++){
                partida.getListaPartidaAtual().get(i).AdicionarPontoBiologico(Integer.parseInt(Messages.getString("PONTOBIOLOGICOFASE4")));
                matrizCodigo.add(partida.getListaPartidaAtual().get(i).getJogador().getCodigo());
                matrizValor.add(partida.getListaPartidaAtual().get(i).getPontos());
           }
           ordenarDecrescente(partida.getListaPartidaAtual().size(), matrizValor, matrizCodigo);
           partida.setOrdemExecucao(matrizCodigo);
      }else
          partida.getOrdemExecucao().remove(codJogador);

      partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
      partida.notificarJogadores();
      return GerentePartida.getInstance().toCenario(partida);

  }
// SE FASE 4 - DIVISAO DE AMEBAS
 public Integer[][] escolherEspaco(Integer codPartida, Integer codJogador,Integer cor){
  int x,y;
  int i,j,z;
  System.out.println("Escolher espaco cor.");
 
  boolean temAmebaCor, temAmebaCorVizinho;
  Espaco[][] espaco;
  Integer[][] espacoNovo= new Integer[5][5];
  //inicializa
  for(i = 0; i < 5; i++)
    for( j = 0; j < 5 ; j++){
       espacoNovo[i][j] = 0;

  }
  Partida partida = GerentePartida.getInstance().getPartida(codPartida);
  if (partida != null){
     
      espaco = partida.getEspacos();
      PartidaAtual partidaAtual = partida.getPartidaAtual(codJogador);

      if (partidaAtual.quantidadeAmebaTabuleiro()!=1){
          
       for(x = 0; x < espaco.length; x++)
         for( y = 0; y < espaco[1].length ; y++){
                temAmebaCor=false;
                
                 for(i = 0; i < espaco[x][y].getAmebas().size();i++)  {
                 
                 if (espaco[x][y].getAmebas().get(i).getCor().equals(cor)){
                      temAmebaCor =true;
                      break;
                 }}
                
                 //if (!partidaAtual.temCartaEsporo()){
                     if (temAmebaCor){
                         //espaco superior

                          if (!( ((x-1) < 0 || (x-1) > 4 )||((x-1) == 0 && y == 0) || ((x-1) == 2 && y == 2)|| ((x-1) == 0 && y == 2)|| ((x-1) == 0 && y == 3) || ((x-1) == 0 && y == 4) || ((x-1) == 4 && y == 4))){

                            ArrayList<Ameba> amebas = espaco[x-1][y].getAmebas();
                            temAmebaCorVizinho = false;
                            for(z = 0; z < amebas.size(); z++)
                                if (amebas.get(z).getCor().equals(cor)){
                                    temAmebaCorVizinho = true;
                                    break;
                                }
                            if (!temAmebaCorVizinho)
                                  espacoNovo[x-1][y] = 1;

                           }
                          //esquerda
                         if (!(((y-1)<0 || (y-1)>4)||(x == 0 && (y-1) == 0) || (x == 2 && (y-1) == 2)|| (x == 0 && (y-1) == 2)|| (x == 0 && (y-1) == 3) || (x == 0 && (y-1) == 4) || (x == 4 && (y-1) == 4))){

                            ArrayList<Ameba> amebas = espaco[x][y-1].getAmebas();
                            temAmebaCorVizinho = false;
                             for(z = 0; z < amebas.size(); z++)
                               if (amebas.get(z).getCor().equals(cor)){
                                   temAmebaCorVizinho = true;
                                   break;
                               }
                              if (!temAmebaCorVizinho)
                                  espacoNovo[x][y-1] = 1;

                         }//
                         //inferior
                         if (!(((x+1)<0 || (x+1)>4)||((x+1) == 0 && y == 0) || ((x+1) == 2 && y == 2)|| ((x+1) == 0 && y == 2)|| ((x+1) == 0 && y == 3) || ((x+1) == 0 && y == 4) || ((x+1) == 4 && y == 4))){

                            ArrayList<Ameba> amebas = espaco[x+1][y].getAmebas();
                            temAmebaCorVizinho=false;
                            for(z = 0; z < amebas.size(); z++)
                               if (amebas.get(z).getCor().equals(cor)){
                                   temAmebaCorVizinho = true;
                                   break;
                               }
                            if (!temAmebaCorVizinho)
                                  espacoNovo[x+1][y] = 1;

                         }
                         //direita
                          if (!(((y+1)<0 || (y+1)>4)||(x == 0 && (y+1) == 0) || (x == 2 && (y+1) == 2)|| (x == 0 && (y+1) == 2)|| (x == 0 && (y+1) == 3) || (x == 0 && (y+1) == 4) || (x == 4 && (y+1) == 4))){

                            ArrayList<Ameba> amebas = espaco[x][y+1].getAmebas();
                            temAmebaCorVizinho=false;
                             for(z = 0; z < amebas.size(); z++)
                                   if (amebas.get(z).getCor().equals(cor)){
                                       temAmebaCorVizinho = true;
                                       break;
                                   }
                              if (!temAmebaCorVizinho)
                                  espacoNovo[x][y+1] = 1;

                          }

                    // }
                    // else{//tem carta gene Esporo, ou seja, pode ser colocada em qualquer espaco que não conhenha ameba da mesma cor.
                    //      if (temAmebaCor)
                    //              espacoNovo[x][y] = 0;
                   //       else    espacoNovo[x][y] = 1;
                  //   }

                 }
                  
              }
             
               return espacoNovo;
            }else{
                 for(x=0;x<espaco.length;x++)
                     for(y=0;y<espaco[1].length;y++){
                        if (!((x == 0 && y == 0) || (x == 2 && y == 2)|| (x == 0 && y == 2)|| (x == 0 && y == 3) || (x == 0 && y == 4) || (x == 4 && y == 4))){
                        
                        ArrayList<Ameba> amebas = espaco[x][y].getAmebas();
                        temAmebaCorVizinho=false;
                         for(z = 0; z < amebas.size(); z++)
                               if (amebas.get(z).getCor() == cor){
                                   temAmebaCorVizinho = true;
                                   break;
                               }
                          if (!temAmebaCorVizinho)
                              espacoNovo[x][y] = 1;
                      }
                     }
                    
               return espacoNovo;
            }
      

    }
  else{

  
  
  return espacoNovo;

  }
  

           
 }

public CenarioTO mudarParaFase5(Integer codPartida, Integer codJogador){
     System.out.println("Cada jogador avisa que está pronto para mudar para fase 5.");
     int i,j,z,t;
     ArrayList<Integer> matrizValor = new ArrayList<Integer>();
     ArrayList<Integer> matrizCodigo = new ArrayList<Integer>();
     Partida partida = GerentePartida.getInstance().getPartida(codPartida);
     Integer valorNutriente=Integer.parseInt(Messages.getString("VALORNUTRIENTEFASE5"));

     if (partida.getOrdemExecucao().size()==1){
           partida.getOrdemExecucao().remove(codJogador);
           partida.setFase(5);
           Espaco [][] espaco = partida.getEspacos();
           //remove do espaco se tiver mais de um ponto prejudicial
           for(i=0;i<espaco.length;i++)
                for(j=0;j<espaco[1].length;j++){
                    for(z=0;z<espaco[i][j].getAmebas().size();z++)
                        if (espaco[i][j].getAmebas().get(z).getPontoPrejudicial()>espaco[i][j].getAmebas().get(z).getValorLimitePrejudicial(partida)){
                               espaco[i][j].getAmebas().get(z).setEstaTabuleiro(false);
                               espaco[i][j].getAmebas().get(z).setX(null);
                               espaco[i][j].getAmebas().get(z).setY(null);
                               espaco[i][j].removeAmeba(espaco[i][j].getAmebas().get(z));
                               espaco[i][j].setNutriente1( espaco[i][j].getNutriente1() + valorNutriente ); 
                               espaco[i][j].setNutriente2( espaco[i][j].getNutriente2() + valorNutriente );
                               espaco[i][j].setNutriente3( espaco[i][j].getNutriente3() + valorNutriente );
                               espaco[i][j].setNutriente4( espaco[i][j].getNutriente4() + valorNutriente );
                        }
                }

           //estabelece a ordem de execucao da proxima rodada
           for(i=0;i<partida.getListaPartidaAtual().size();i++){
                matrizCodigo.add(partida.getListaPartidaAtual().get(i).getJogador().getCodigo());
                matrizValor.add(partida.getListaPartidaAtual().get(i).getPontos());
           }
           ordenarDecrescente(partida.getListaPartidaAtual().size(), matrizValor, matrizCodigo);
           partida.setOrdemExecucao(matrizCodigo);
      }else
          partida.getOrdemExecucao().remove(codJogador);

      partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
      partida.notificarJogadores();
      return GerentePartida.getInstance().toCenario(partida);

 }


public CenarioTO calcularPontuacao(Integer codPartida, Integer codJogador) throws SQLException{
    int i;
    System.out.println("Calculando a pontuacao da rodada.");
     Integer contadorAmeba = 0, contadorGene=0;
    Integer pontuacaoRodada;
    Partida partida = GerentePartida.getInstance().getPartida(codPartida);
    PartidaAtual partidaAtual  = partida.getPartidaAtual(codJogador);
    Integer adicaoCartaAvancada = Integer.parseInt(Messages.getString("ADICAOCARTAAVANCADA"));
    Integer adicaoCartaSimples = Integer.parseInt(Messages.getString("ADICAOCARTASIMPLES"));
   
    if (partida!=null){
        for(i=0; i<partidaAtual.getListaAmebas().size(); i++){
              if (partidaAtual.getListaAmebas().get(i).getEstaTabuleiro())
                  contadorAmeba=contadorAmeba + 1;
        }
        
        for(i=0;i<partidaAtual.getCartasGene().size();i++){
            if (partidaAtual.getCartasGene().get(i).getNome().equals("Proteção Raios")){/*Nao adiciona pontos*/}
            else if (partidaAtual.getCartasGene().get(i).getNome().equals("Movimento2")||partidaAtual.getCartasGene().get(i).getNome().equals("Agressão")||partidaAtual.getCartasGene().get(i).getNome().equals("Carapaça")||partidaAtual.getCartasGene().get(i).getNome().equals("Persistência")){
                        contadorGene = contadorGene + adicaoCartaAvancada;
            }else contadorGene = contadorGene + adicaoCartaSimples;
        }
        //tabela de evolucao
        pontuacaoRodada = computarTabela(contadorAmeba,contadorGene);
        
        ArrayList<Integer> pontosJogadores= new ArrayList<Integer>();
        for(i=0; i<partida.QuantidadeJogadores(); i++){
              if (partida.getListaPartidaAtual().get(i).getJogador().getCodigo()!= codJogador)
                  pontosJogadores.add(partida.getListaPartidaAtual().get(i).getPontos());
        }
        i=0;
        while(i<partida.QuantidadeJogadores()-1){
            if((pontosJogadores.get(i)>partidaAtual.getPontos()) && pontosJogadores.get(i)<=(pontuacaoRodada+partidaAtual.getPontos()))
                pontuacaoRodada++;
            i++;
        }
        
        partidaAtual.AtualizarPontuacao(pontuacaoRodada);
        mudarRodada(partida,codJogador);
        partida.setAtualizacaoCenario(GerentePartida.getInstance().getCalendar());
        partida.notificarJogadores();
        return(GerentePartida.getInstance().toCenario(partida));
    }
return null;
}

//decidir melhor o fim de jogo e gravar o historico no banco.
public void mudarRodada(Partida partida, Integer codJogador) throws SQLException{
     System.out.println("Mudando de rodada.");
     int i,j,z,t;
     int indiceVencedor=0;
     Boolean eFimJogo= false;
     Integer zonaNegra = Integer.parseInt(Messages.getString("ZONANEGRA"));
     ArrayList<Integer> matrizValor = new ArrayList<Integer>();
     ArrayList<Integer> matrizCodigo = new ArrayList<Integer>();
     if (partida.getOrdemExecucao().size()==1){
           partida.getOrdemExecucao().remove(codJogador);
           //verifica se chegou a zona de finalizacao
           for(i=0;i<partida.QuantidadeJogadores();i++){
                if(partida.getListaPartidaAtual().get(indiceVencedor).getPontos()<partida.getListaPartidaAtual().get(i).getPontos())
                    indiceVencedor = i;
           }
           System.out.println("ponto maior"+partida.getListaPartidaAtual().get(indiceVencedor).getPontos()+" -zonanegra"+ zonaNegra);
           if (partida.getListaPartidaAtual().get(indiceVencedor).getPontos()>=zonaNegra){
                        eFimJogo =true;
                       
           }
           
           //verifica se acabaram as cartas ambiente
           if(!eFimJogo){
               if (partida.getCartaAmbienteAtual().getCodigo()==partida.getCartaAmbiente().getLast().getCodigo())
                   eFimJogo = true;
           }
           if(eFimJogo){
              partida.setPartidaFechada(true);
              partida.setVencedor(partida.getListaPartidaAtual().get(indiceVencedor).getJogador().getCodigo());
              PrimordialSoupDAO DAO = new PrimordialSoupDAO();
              DAO.insereCenarioFinal(partida);

           }
           else{
             partida.setFase(1);
             partida.setRodada(partida.getRodada()+1);
             System.out.println("fase 1 novamente");
             //estabelece a ordem de execucao da proxima rodada
             for(i=0;i<partida.getListaPartidaAtual().size();i++){
                matrizCodigo.add(partida.getListaPartidaAtual().get(i).getJogador().getCodigo());
                matrizValor.add(partida.getListaPartidaAtual().get(i).getPontos());
             }
             ordenarCrescente(partida.getListaPartidaAtual().size(), matrizValor, matrizCodigo);
             partida.setOrdemExecucao(matrizCodigo);
           }
           System.out.println("Fim de jogo?:"+ eFimJogo);
      }else
          partida.getOrdemExecucao().remove(codJogador);



 }





public Integer computarTabela(Integer contadorAmeba, Integer contadorGene){
  Integer contadorParcial=0;
    if(contadorAmeba == 3)
        contadorParcial = 1;
    else if(contadorAmeba == 4)
        contadorParcial = 2;
    else if(contadorAmeba == 5)
        contadorParcial = 4;
    else if(contadorAmeba == 6)
       contadorParcial = 5;
    else if (contadorAmeba == 7)
       contadorParcial = 6;

   if(contadorGene == 3)
        contadorParcial = contadorParcial + 1;
    else if(contadorGene == 4)
        contadorParcial = contadorParcial + 2;
    else if(contadorGene == 5)
        contadorParcial = contadorParcial + 3;
    else if(contadorGene >= 6)
       contadorParcial = contadorParcial + 4;

  return contadorParcial;

}


public void ordenarCrescente(Integer numero,ArrayList<Integer>matrizValor, ArrayList<Integer> matrizCodigo){
    int i,j;
    Integer max, codigo;

                    //ordena os jogadores do menor valor para o maior valor
                    for (i=1 ; i< numero; i++){             //ordena o array de maiores
                        max    = matrizValor.get(i);
                        codigo =  matrizCodigo.get(i);
                        for(j=i;j>0;j--)
                        {
                            if (matrizValor.get(j-1) > max){
                               matrizValor.set(j,matrizValor.get(j-1));
                               matrizCodigo.set(j,matrizCodigo.get(j-1)) ;
                           }
                            else
                              break;
                        }

                        matrizValor.set(j,max);
                        matrizCodigo.set(j, codigo);

                   }


}

public void ordenarDecrescente(Integer numero,ArrayList<Integer>matrizValor, ArrayList<Integer> matrizCodigo){
    int i,j;
    Integer min, codigo;

     //ordena os jogadores do maior valor para o menor valor
     for (i=1 ; i< numero; i++){             //ordena o array de maiores
         min    = matrizValor.get(i);
         codigo =  matrizCodigo.get(i);
         for(j=i;j>0;j--)
            {
                if (matrizValor.get(j-1) < min){
                  matrizValor.set(j,matrizValor.get(j-1));
                  matrizCodigo.set(j,matrizCodigo.get(j-1)) ;
                }
                else
                 break;
                }

           matrizValor.set(j,min);
           matrizCodigo.set(j, codigo);

        }


}


}




