/*Maysa Macedo- maysa ( at) ime.usp.br*/

package primordialsoupservidor;



import bancodados.PrimordialSoupDAO;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.LinkedList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author maysa
 */
public class Jogador 
{
    private Integer codigo;
    private String nome;
    private String senha;
    private Integer opcaoLogin;
    private Timestamp ultimoAcesso;
    private LinkedList<PartidaAtual> partidasatuais;
    private Integer valorDado;
   

   public Jogador() 
   { //super() ;
      valorDado=0;
   } // constructor


   public Jogador(String nome, String senha){
       this.nome = nome;
       this.senha = senha;
       valorDado=0;
   }

    public Jogador getJogador(){
       return this;
    }

    public void setNome(String nome) {
        this.nome = nome;
    }
     public String getNome(){
         return this.nome;
    }

     public String getSenha(){
         return this.senha;
    }

     public void setSenha(String senha) {
        this.senha = senha;
    }


    public LinkedList<PartidaAtual> getPartidasatuais() {
        return partidasatuais;
    }

  
    public void setPartidasatuais(LinkedList<PartidaAtual> partidasatuais) {
        this.setPartidasatuais(partidasatuais);
    }

    /**
     * @return the codigo
     */
    public Integer getCodigo() {
        return codigo;
    }

    /**
     * @param codigo the codigo to set
     */
    public void setCodigo(Integer codigo) {
        this.codigo = codigo;
    }

    /**
     * @return the opcaoLogin
     */
    public Integer getOpcaoLogin() {
        return opcaoLogin;
    }

    /**
     * @param opcaoLogin the opcaoLogin to set
     */
    public void setOpcaoLogin(Integer opcaoLogin) {
        this.opcaoLogin = opcaoLogin;
    }

    /**
     * @return the ultimoAcesso
     */
    public Timestamp getUltimoAcesso() {
        return ultimoAcesso;
    }

    /**
     * @param ultimoAcesso the ultimoAcesso to set
     */
    public void setUltimoAcesso(Timestamp ultimoAcesso) {
        this.ultimoAcesso = ultimoAcesso;
    }

  
    public Timestamp getTimestamp(){
     Calendar calendar = new GregorianCalendar();
     Timestamp timeStamp = new Timestamp(calendar.getTimeInMillis());
     return timeStamp;
    }
    /**
     * @return the valorDado
     */
    public Integer getValorDado() {
        return valorDado;
    }

    /**
     * @param valorDado the valorDado to set
     */
    public void setValorDado(Integer valorDado) {
        this.valorDado = valorDado;
    }

  
}

/*   
*/