/*Maysa Macedo- maysa ( at) ime.usp.br*/

import bancodados.PrimordialSoupDAO;
import java.sql.SQLException;
import primordialsoupservidor.CartaAmbiente;
import primordialsoupservidor.CartaGene;


public class CarregaBanco {
PrimordialSoupDAO primordial;

public  CarregaBanco(){
     try {
         primordial = new PrimordialSoupDAO();
         carregaCartaAmbiente();
         carregarCatalogoGene();
         System.out.println( "Carregado!" );


     }
     catch( Exception e ) {
        System.out.println( "Trouble1: " + e );
     }
}
    

  public void carregaCartaAmbiente() throws SQLException{
      int i;

    for(i=1; i< Integer.parseInt(Messages.getString("NUMEROCARTAAMBIENTE"))+1; i++){
            CartaAmbiente carta =new CartaAmbiente();
            carta.setCodigo(i);
            carta.setCamaOzonio(Integer.parseInt(Messages.getString("CAMADAOZONIO"+ i)));
            carta.setDirecao(Integer.parseInt(Messages.getString("DIRECAO"+ i)));
            primordial.adicionaCartaAmbiente(carta);

    }}

 public void carregarCatalogoGene() throws SQLException{
    int i;
    Integer numerocartagene = Integer.parseInt(Messages.getString("NUMEROCARTAGENE"));

    for(i=1;i<numerocartagene+1;i++){
        CartaGene cartagene = new CartaGene();
        cartagene.setCodigo(i);
        cartagene.setNome(Messages.getString("GENENOME"+i));
        cartagene.setPontoMutacao(Integer.parseInt(Messages.getString("GENEMUTACAO"+i)));
        cartagene.setPreco(Integer.parseInt(Messages.getString("GENEPRECO"+i)));
        primordial.adicionaCartaGene(cartagene);

      }
     }


  public static void main(String[] args) {
    System.out.println( "Carregando Banco..." );
     new CarregaBanco();
  }
}
