/*Maysa Macedo- maysa ( at) ime.usp.br*/
package primordialsoupservidor;


import java.io.IOException;
import java.io.PrintStream;
import java.net.Socket;
import java.util.Vector;


public class AtualizadorCenarioServidor {

    private Vector<Socket> sockets = new Vector<Socket>();
    private Vector<Integer> jogadores =  new Vector<Integer>();

    public void addSocket(Socket s, Integer idJogador){
        sockets.add(s);
        jogadores.add(idJogador); 
    }
    
    // enviar uma mensagem para todos
    public void notificarClientes(String codeMsg) throws IOException {
        System.out.println("notificando os clientes");
        for(int i=0; i < sockets.size(); i++){
            Socket s = sockets.get(i);
            PrintStream saida = new PrintStream(s.getOutputStream());
            saida.println(codeMsg);
        }
    }

    public void notificarJogador(Integer idJogador, String codeMsg) throws IOException{
        for(int i=0; i < jogadores.size(); i++){
            if(jogadores.get(i).equals(idJogador)){
                Socket s = sockets.get(i);
                PrintStream saida = new PrintStream(s.getOutputStream());
                saida.println(codeMsg);
                break;
            }
        }
    }


    public void fecharSockets() throws IOException{
        for(int i=0; i < jogadores.size(); i++){
            Socket s = sockets.get(i);
            s.close();
        }
    }
}
