/*Maysa Macedo- maysa ( at) ime.usp.br*/
package primordialsoupservidor;



import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 
 *  
 * @description 
 * Classe utilizada para carregar o arquivo de configuracao (config.properties)
 * 
 */
public class Messages { 
	
	private static final String BUNDLE_NAME = "config"; 
	
	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME);

	private Messages() {
	}

	public static String getString(String key) {
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}

	
}
